Index: trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.cpp	(revision 91958)
+++ trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.cpp	(revision 91959)
@@ -2785,11 +2785,11 @@
 
 /*********************************************************************************************************************************
-*   Class UINotificationProgressApplianceExport implementation.                                                                  *
-*********************************************************************************************************************************/
-
-UINotificationProgressApplianceExport::UINotificationProgressApplianceExport(const CAppliance &comAppliance,
-                                                                             const QString &strFormat,
-                                                                             const QVector<KExportOptions> &options,
-                                                                             const QString &strPath)
+*   Class UINotificationProgressApplianceWrite implementation.                                                                   *
+*********************************************************************************************************************************/
+
+UINotificationProgressApplianceWrite::UINotificationProgressApplianceWrite(const CAppliance &comAppliance,
+                                                                           const QString &strFormat,
+                                                                           const QVector<KExportOptions> &options,
+                                                                           const QString &strPath)
     : m_comAppliance(comAppliance)
     , m_strFormat(strFormat)
@@ -2799,15 +2799,15 @@
 }
 
-QString UINotificationProgressApplianceExport::name() const
-{
-    return UINotificationProgress::tr("Exporting appliance ...");
-}
-
-QString UINotificationProgressApplianceExport::details() const
+QString UINotificationProgressApplianceWrite::name() const
+{
+    return UINotificationProgress::tr("Writing appliance ...");
+}
+
+QString UINotificationProgressApplianceWrite::details() const
 {
     return UINotificationProgress::tr("<b>To:</b> %1").arg(m_strPath);
 }
 
-CProgress UINotificationProgressApplianceExport::createProgress(COMResult &comResult)
+CProgress UINotificationProgressApplianceWrite::createProgress(COMResult &comResult)
 {
     /* Initialize progress-wrapper: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.h	(revision 91958)
+++ trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.h	(revision 91959)
@@ -1550,33 +1550,33 @@
 };
 
-/** UINotificationProgress extension for export appliance functionality. */
-class SHARED_LIBRARY_STUFF UINotificationProgressApplianceExport : public UINotificationProgress
-{
-    Q_OBJECT;
-
-public:
-
-    /** Constructs export appliance notification-progress.
-      * @param  comAppliance  Brings the appliance being exported.
+/** UINotificationProgress extension for appliance write functionality. */
+class SHARED_LIBRARY_STUFF UINotificationProgressApplianceWrite : public UINotificationProgress
+{
+    Q_OBJECT;
+
+public:
+
+    /** Constructs appliance write notification-progress.
+      * @param  comAppliance  Brings the appliance being written.
       * @param  strFormat     Brings the appliance format.
       * @param  options       Brings the export options to be taken into account.
       * @param  strPath       Brings the appliance path. */
-    UINotificationProgressApplianceExport(const CAppliance &comAppliance,
-                                          const QString &strFormat,
-                                          const QVector<KExportOptions> &options,
-                                          const QString &strPath);
-
-protected:
-
-    /** Returns object name. */
-    virtual QString name() const /* override final */;
-    /** Returns object details. */
-    virtual QString details() const /* override final */;
-    /** Creates and returns started progress-wrapper. */
-    virtual CProgress createProgress(COMResult &comResult) /* override final */;
-
-private:
-
-    /** Holds the appliance being exported. */
+    UINotificationProgressApplianceWrite(const CAppliance &comAppliance,
+                                         const QString &strFormat,
+                                         const QVector<KExportOptions> &options,
+                                         const QString &strPath);
+
+protected:
+
+    /** Returns object name. */
+    virtual QString name() const /* override final */;
+    /** Returns object details. */
+    virtual QString details() const /* override final */;
+    /** Creates and returns started progress-wrapper. */
+    virtual CProgress createProgress(COMResult &comResult) /* override final */;
+
+private:
+
+    /** Holds the appliance being written. */
     CAppliance               m_comAppliance;
     /** Holds the appliance format. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportApp.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportApp.cpp	(revision 91958)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportApp.cpp	(revision 91959)
@@ -310,8 +310,8 @@
     {
         /* Export appliance: */
-        UINotificationProgressApplianceExport *pNotification = new UINotificationProgressApplianceExport(comAppliance,
-                                                                                                         format(),
-                                                                                                         options,
-                                                                                                         uri());
+        UINotificationProgressApplianceWrite *pNotification = new UINotificationProgressApplianceWrite(comAppliance,
+                                                                                                       format(),
+                                                                                                       options,
+                                                                                                       uri());
         if (cloudExportMode() == CloudExportMode_DoNotAsk)
             gpNotificationCenter->append(pNotification);
@@ -323,8 +323,8 @@
     {
         /* Export appliance: */
-        UINotificationProgressApplianceExport *pNotification = new UINotificationProgressApplianceExport(comAppliance,
-                                                                                                         format(),
-                                                                                                         options,
-                                                                                                         uri());
+        UINotificationProgressApplianceWrite *pNotification = new UINotificationProgressApplianceWrite(comAppliance,
+                                                                                                       format(),
+                                                                                                       options,
+                                                                                                       uri());
         gpNotificationCenter->append(pNotification);
     }