Index: trunk/src/VBox/Frontends/VirtualBox/src/cloud/machinesettings/UICloudMachineSettingsDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/cloud/machinesettings/UICloudMachineSettingsDialog.cpp	(revision 92151)
+++ trunk/src/VBox/Frontends/VirtualBox/src/cloud/machinesettings/UICloudMachineSettingsDialog.cpp	(revision 92152)
@@ -22,8 +22,8 @@
 /* GUI includes: */
 #include "QIDialogButtonBox.h"
-#include "UIMessageCenter.h"
 #include "UICloudMachineSettingsDialog.h"
 #include "UICloudMachineSettingsDialogPage.h"
 #include "UICloudNetworkingStuff.h"
+#include "UINotificationCenter.h"
 
 /* COM includes: */
@@ -36,6 +36,12 @@
     , m_pPage(0)
     , m_pButtonBox(0)
+    , m_pNotificationCenter(0)
 {
     prepare();
+}
+
+UICloudMachineSettingsDialog::~UICloudMachineSettingsDialog()
+{
+    cleanup();
 }
 
@@ -100,4 +106,7 @@
 void UICloudMachineSettingsDialog::prepare()
 {
+    /* Prepare local notification-center (parent to be assigned in the end): */
+    m_pNotificationCenter = new UINotificationCenter(0);
+
     /* Prepare layout: */
     QVBoxLayout *pLayout = new QVBoxLayout(this);
@@ -128,5 +137,15 @@
     }
 
+    /* Assign notification-center parent (after everything else is done): */
+    m_pNotificationCenter->setParent(this);
+
     /* Apply language settings: */
     retranslateUi();
 }
+
+void UICloudMachineSettingsDialog::cleanup()
+{
+    /* Cleanup local notification-center: */
+    delete m_pNotificationCenter;
+    m_pNotificationCenter = 0;
+}
Index: trunk/src/VBox/Frontends/VirtualBox/src/cloud/machinesettings/UICloudMachineSettingsDialog.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/cloud/machinesettings/UICloudMachineSettingsDialog.h	(revision 92151)
+++ trunk/src/VBox/Frontends/VirtualBox/src/cloud/machinesettings/UICloudMachineSettingsDialog.h	(revision 92152)
@@ -37,4 +37,5 @@
 /* Forward declarations: */
 class QIDialogButtonBox;
+class UINotificationCenter;
 
 /** Cloud machine settings dialog. */
@@ -47,4 +48,9 @@
     /** Constructs @a comCloudMachine settings dialog passing @a pParent to the base-class. */
     UICloudMachineSettingsDialog(QWidget *pParent, const CCloudMachine &comCloudMachine);
+    /** Destructs cloud machine settings dialog. */
+    virtual ~UICloudMachineSettingsDialog() /* override final */;
+
+    /** Returns local notification-center reference. */
+    UINotificationCenter *notificationCenter() const { return m_pNotificationCenter; }
 
 public slots:
@@ -73,4 +79,6 @@
     /** Prepares all. */
     void prepare();
+    /** Cleanups all. */
+    void cleanup();
 
     /** Holds the cloud machine object reference. */
@@ -85,4 +93,7 @@
     /** Holds the dialog button-box instance. */
     QIDialogButtonBox                           *m_pButtonBox;
+
+    /** Holds the local notification-center instance. */
+    UINotificationCenter *m_pNotificationCenter;
 };
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/cloud/machinesettings/UICloudMachineSettingsDialogPage.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/cloud/machinesettings/UICloudMachineSettingsDialogPage.cpp	(revision 92151)
+++ trunk/src/VBox/Frontends/VirtualBox/src/cloud/machinesettings/UICloudMachineSettingsDialogPage.cpp	(revision 92152)
@@ -21,4 +21,5 @@
 
 /* GUI includes: */
+#include "UICloudMachineSettingsDialog.h"
 #include "UICloudMachineSettingsDialogPage.h"
 
@@ -27,6 +28,8 @@
 
 
-UICloudMachineSettingsDialogPage::UICloudMachineSettingsDialogPage(QWidget *pParent, bool fFullScale /* = true */)
+UICloudMachineSettingsDialogPage::UICloudMachineSettingsDialogPage(QWidget *pParent,
+                                                                   bool fFullScale /* = true */)
     : QWidget(pParent)
+    , m_pParent(qobject_cast<UICloudMachineSettingsDialog*>(pParent))
     , m_fFullScale(fFullScale)
 {
@@ -61,5 +64,5 @@
 
         /* Prepare form editor widget: */
-        m_pFormEditor = new UIFormEditorWidget(this);
+        m_pFormEditor = new UIFormEditorWidget(this, m_pParent ? m_pParent->notificationCenter() : 0);
         if (m_pFormEditor)
         {
Index: trunk/src/VBox/Frontends/VirtualBox/src/cloud/machinesettings/UICloudMachineSettingsDialogPage.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/cloud/machinesettings/UICloudMachineSettingsDialogPage.h	(revision 92151)
+++ trunk/src/VBox/Frontends/VirtualBox/src/cloud/machinesettings/UICloudMachineSettingsDialogPage.h	(revision 92152)
@@ -32,4 +32,7 @@
 #include "COMEnums.h"
 #include "CForm.h"
+
+/* Forward declarations: */
+class UICloudMachineSettingsDialog;
 
 /** Cloud machine settings dialog page. */
@@ -72,4 +75,7 @@
     void updateEditor();
 
+    /** Holds the parent cloud machine settings dialog reference. */
+    UICloudMachineSettingsDialog *m_pParent;
+
     /** Holds whether this page is full-scale and should reflect at least 12 fields. */
     bool  m_fFullScale;