Index: /trunk/src/VBox/VMM/VMMR0/GMMR0.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMR0/GMMR0.cpp	(revision 92248)
+++ /trunk/src/VBox/VMM/VMMR0/GMMR0.cpp	(revision 92249)
@@ -181,4 +181,9 @@
 #include <iprt/time.h>
 
+/* This is 64-bit only code now. */
+#if HC_ARCH_BITS != 64 || ARCH_BITS != 64
+# error "This is 64-bit only code"
+#endif
+
 
 /*********************************************************************************************************************************
@@ -204,14 +209,9 @@
  * The per-page tracking structure employed by the GMM.
  *
- * On 32-bit hosts we'll some trickery is necessary to compress all
- * the information into 32-bits. When the fSharedFree member is set,
- * the 30th bit decides whether it's a free page or not.
- *
- * Because of the different layout on 32-bit and 64-bit hosts, macros
- * are used to get and set some of the data.
+ * Because of the different layout on 32-bit and 64-bit hosts in earlier
+ * versions of the code, macros are used to get and set some of the data.
  */
 typedef union GMMPAGE
 {
-#if HC_ARCH_BITS == 64
     /** Unsigned integer view. */
     uint64_t u;
@@ -264,48 +264,4 @@
         uint32_t    u2State : 2;
     } Free;
-
-#else /* 32-bit */
-    /** Unsigned integer view. */
-    uint32_t u;
-
-    /** The common view. */
-    struct GMMPAGECOMMON
-    {
-        uint32_t    uStuff : 30;
-        /** The page state. */
-        uint32_t    u2State : 2;
-    } Common;
-
-    /** The view of a private page. */
-    struct GMMPAGEPRIVATE
-    {
-        /** The guest page frame number. (Max addressable: 2 ^ 36) */
-        uint32_t    pfn : 24;
-        /** The GVM handle. (127 VMs) */
-        uint32_t    hGVM : 7;
-        /** The top page state bit, MBZ. */
-        uint32_t    fZero : 1;
-    } Private;
-
-    /** The view of a shared page. */
-    struct GMMPAGESHARED
-    {
-        /** The reference count. */
-        uint32_t    cRefs : 30;
-        /** The page state. */
-        uint32_t    u2State : 2;
-    } Shared;
-
-    /** The view of a free page. */
-    struct GMMPAGEFREE
-    {
-        /** The index of the next page in the free list. UINT16_MAX is NIL. */
-        uint32_t    iNext : 16;
-        /** Reserved. Checksum or something? */
-        uint32_t    u14Reserved : 14;
-        /** The page state. */
-        uint32_t    u2State : 2;
-    } Free;
-#endif
 } GMMPAGE;
 AssertCompileSize(GMMPAGE, sizeof(RTHCUINTPTR));
@@ -318,7 +274,4 @@
 /** A private page. */
 #define GMM_PAGE_STATE_PRIVATE          0
-/** A private page - alternative value used on the 32-bit implementation.
- * This will never be used on 64-bit hosts. */
-#define GMM_PAGE_STATE_PRIVATE_32       1
 /** A shared page. */
 #define GMM_PAGE_STATE_SHARED           2
@@ -333,9 +286,5 @@
  * @param   pPage       The GMM page.
  */
-#if HC_ARCH_BITS == 64
-# define GMM_PAGE_IS_PRIVATE(pPage) ( (pPage)->Common.u2State == GMM_PAGE_STATE_PRIVATE )
-#else
-# define GMM_PAGE_IS_PRIVATE(pPage) ( (pPage)->Private.fZero == 0 )
-#endif
+#define GMM_PAGE_IS_PRIVATE(pPage)  ( (pPage)->Common.u2State == GMM_PAGE_STATE_PRIVATE )
 
 /** @def GMM_PAGE_IS_SHARED
@@ -358,19 +307,11 @@
  *         see GMM_PAGE_PFN_UNSHAREABLE.
  */
-#if HC_ARCH_BITS == 64
-# define GMM_PAGE_PFN_LAST           UINT32_C(0xfffffff0)
-#else
-# define GMM_PAGE_PFN_LAST           UINT32_C(0x00fffff0)
-#endif
-AssertCompile(GMM_PAGE_PFN_LAST        == (GMM_GCPHYS_LAST >> PAGE_SHIFT));
+#define GMM_PAGE_PFN_LAST            UINT32_C(0xfffffff0)
+AssertCompile(GMM_PAGE_PFN_LAST == (GMM_GCPHYS_LAST >> PAGE_SHIFT));
 
 /** @def GMM_PAGE_PFN_UNSHAREABLE
  * Indicates that this page isn't used for normal guest memory and thus isn't shareable.
  */
-#if HC_ARCH_BITS == 64
-# define GMM_PAGE_PFN_UNSHAREABLE   UINT32_C(0xfffffff1)
-#else
-# define GMM_PAGE_PFN_UNSHAREABLE   UINT32_C(0x00fffff1)
-#endif
+#define GMM_PAGE_PFN_UNSHAREABLE    UINT32_C(0xfffffff1)
 AssertCompile(GMM_PAGE_PFN_UNSHAREABLE == (GMM_GCPHYS_UNSHAREABLE >> PAGE_SHIFT));
 
@@ -3646,5 +3587,5 @@
                 Assert(pGVM->gmm.s.Stats.cSharedPages);
                 Assert(pPage->Shared.cRefs);
-#if defined(VBOX_WITH_PAGE_SHARING) && defined(VBOX_STRICT) && HC_ARCH_BITS == 64
+#if defined(VBOX_WITH_PAGE_SHARING) && defined(VBOX_STRICT)
                 if (pPage->Shared.u14Checksum)
                 {
@@ -4210,5 +4151,5 @@
 
 
-#if defined(VBOX_WITH_PAGE_SHARING) || (defined(VBOX_STRICT) && HC_ARCH_BITS == 64)
+#if defined(VBOX_WITH_PAGE_SHARING) || defined(VBOX_STRICT)
 /**
  * Check if a chunk is mapped into the specified VM
@@ -4238,5 +4179,5 @@
     return false;
 }
-#endif /* VBOX_WITH_PAGE_SHARING || (VBOX_STRICT && 64-BIT) */
+#endif /* VBOX_WITH_PAGE_SHARING || VBOX_STRICT */
 
 
@@ -5339,5 +5280,5 @@
 }
 
-#if defined(VBOX_STRICT) && HC_ARCH_BITS == 64
+#ifdef VBOX_STRICT
 
 /**
@@ -5449,5 +5390,5 @@
 }
 
-#endif /* VBOX_STRICT && HC_ARCH_BITS == 64 */
+#endif /* VBOX_STRICT */
 
 